<?php

declare(strict_types=1);

namespace App\Domain\Entity\Property;

enum PropertyUsageBusinessType: int
{
    case KIOSK = 0;
    case GAS_STATION = 1;
    case PRICE_BREAKER = 2;
    case RETAIL_WITHOUT_SHOWROOM = 3;
    case SPECIALITY_STORE = 4;
    case SPECIALITY_MARKET = 5;
    case SUPERMARKET = 6;
    case CONSUMER_MARKET = 7;
    case SELF_SERVICE_DEPARTMENT_STORE = 8;
    case DISCOUNTER = 9;
    case DEPARTMENT_STORE = 10;
    case WAREHOUSE = 11;
    case BOUTIQUE = 12;
    case POPUP_STORE = 13;
    case SHOWROOM = 14;
    case FACTORY_OUTLET = 15;
    case OFFICE = 16;
    case CO_WORKING_SPACE = 17;
    case ATELIER = 18;
    case BANK = 19;
    case POST_OFFICE = 20;
    case PRACTICE = 21;
    case WORKSHOP = 22;
    case BEARING = 23;
    case ARCHIVE = 24;
    case LABORATORY = 25;
    case HOTEL = 26;
    case INN = 27;
    case PENSION = 28;
    case YOUTH_HOSTEL = 29;
    case RESTAURANT = 30;
    case RESTAURANT_WITH_SELF_SERVICE = 31;
    case COFFEE_SHOP = 32;
    case SNACK_BAR = 33;
    case PUB = 34;
    case ONE_ROOM_PUB = 35;
    case DISCOTHEQUE = 36;
    case CANTEEN = 37;
    case DELIVERY_SERVICE = 38;
    case BROTHEL = 39;
    case HIGH_BAY_WAREHOUSE = 40;
    case HALL = 41;
    case SHIPPING_COMPANY = 42;
    case PRODUCTION = 43;
    case COLD_STORAGE = 44;
    case DATA_CENTER = 45;
    case CAR_PARK = 46;
    case UNDERGROUND_CAR_PARK = 47;
    case PARKING_LOT = 48;
    case PARKING_SPACE = 49;
    case GARAGE = 50;
    case LIBRARY = 51;
    case SCHOOL = 52;
    case UNIVERSITY = 53;
    case UNIVERSITY_OF_APPLIED_SCIENCE = 54;
    case RESEARCH_INSTITUTION = 55;
    case KINDERGARTEN = 56;
    case DAY_CARE_CENTER = 57;
    case ORPHANAGE = 58;
    case RETIREMENT_HOME = 59;
    case STUDENT_RESIDENCE = 60;
    case WOMENS_SHELTER = 61;
    case NURSING_SERVICE = 62;
    case HOSPITAL = 63;
    case FIRE_STATION = 64;
    case POLICE_STATION = 65;
    case RESCUE_STATION = 66;
    case THEATER = 67;
    case MUSEUM = 68;
    case CINEMA = 69;
    case CHURCH = 70;
    case SPORTS_FACILITY = 71;
    case PLAYGROUND = 72;
    case CLIMBING_HALL = 73;
    case PARK = 74;
    case OTHER_RECREATIONAL_FACILITY = 75;
    case SIGHT = 76;
    case TOWN_HALL = 77;
    case CITIZENS_BUREAU = 78;
    case CIVIC_CENTER = 79;
    case COURT = 80;
    case OTHER_PUBLIC_FACILITY = 81;

    public function getName(): string
    {
        return match ($this) {
            self::KIOSK => 'Kiosk',
            self::GAS_STATION => 'Tankstelle',
            self::PRICE_BREAKER => 'Preisbrecher',
            self::RETAIL_WITHOUT_SHOWROOM => 'Einzelhandel ohne Verkaufsraum',
            self::SPECIALITY_STORE => 'Fachgeschäft',
            self::SPECIALITY_MARKET => 'Fachmarkt',
            self::SUPERMARKET => 'Supermarkt',
            self::CONSUMER_MARKET => 'Verbrauchermarkt',
            self::SELF_SERVICE_DEPARTMENT_STORE => 'Selbstbedienungswarenhaus',
            self::DISCOUNTER => 'Discounter',
            self::DEPARTMENT_STORE => 'Kaufhaus',
            self::WAREHOUSE => 'Warenhaus',
            self::BOUTIQUE => 'Boutique',
            self::POPUP_STORE => 'Popup-Store',
            self::SHOWROOM => 'Ausstellungsfläche',
            self::FACTORY_OUTLET => 'Factory Outlet',
            self::OFFICE => 'Büro',
            self::CO_WORKING_SPACE => 'CoWorking-Space',
            self::ATELIER => 'Atelier',
            self::BANK => 'Bank',
            self::POST_OFFICE => 'Post',
            self::PRACTICE => 'Praxis',
            self::WORKSHOP => 'Werkstatt',
            self::BEARING => 'Lager',
            self::ARCHIVE => 'Archiv',
            self::LABORATORY => 'Laboratorium',
            self::HOTEL => 'Hotel',
            self::INN => 'Gasthof',
            self::PENSION => 'Pension',
            self::YOUTH_HOSTEL => 'Jugendherberge',
            self::RESTAURANT => 'Restaurant mit herkömmlicher Bedienung',
            self::RESTAURANT_WITH_SELF_SERVICE => 'Restaurant mit Selbstbedienung',
            self::COFFEE_SHOP => 'Café, Eissalon, Bistro',
            self::SNACK_BAR => 'Imbissstube',
            self::PUB => 'Kneipe, Bar, Lokal',
            self::ONE_ROOM_PUB => 'Einraumlokal',
            self::DISCOTHEQUE => 'Diskothek, Tanzlokal',
            self::CANTEEN => 'Kantine',
            self::DELIVERY_SERVICE => 'Caterer, Lieferservice',
            self::BROTHEL => 'Bordell',
            self::HIGH_BAY_WAREHOUSE => 'Hochregallager',
            self::HALL => 'Halle',
            self::SHIPPING_COMPANY => 'Spedition',
            self::PRODUCTION => 'Produktion',
            self::COLD_STORAGE => 'Kühlhaus',
            self::DATA_CENTER => 'Rechenzentrum',
            self::CAR_PARK => 'Parkhaus',
            self::UNDERGROUND_CAR_PARK => 'Tiefgarage',
            self::PARKING_LOT => 'Parkplatz',
            self::PARKING_SPACE => 'Stellplatz',
            self::GARAGE => 'Garage',
            self::LIBRARY => 'Bibliothek',
            self::SCHOOL => 'Schule',
            self::UNIVERSITY => 'Universität',
            self::UNIVERSITY_OF_APPLIED_SCIENCE => 'Hochschule',
            self::RESEARCH_INSTITUTION => 'Forschungseinrichtung',
            self::KINDERGARTEN => 'Kindergarten',
            self::DAY_CARE_CENTER => 'Kindertagesstätte',
            self::ORPHANAGE => 'Waisenhaus',
            self::RETIREMENT_HOME => 'Altenheim, Pflegeheim',
            self::STUDENT_RESIDENCE => 'Studentenwohnheim',
            self::WOMENS_SHELTER => 'Frauenhaus',
            self::NURSING_SERVICE => 'Pflegedienst',
            self::HOSPITAL => 'Krankenhaus',
            self::FIRE_STATION => 'Feuerwache',
            self::POLICE_STATION => 'Polizeiwache',
            self::RESCUE_STATION => 'Rettungswache',
            self::THEATER => 'Theater',
            self::MUSEUM => 'Museum',
            self::CINEMA => 'Kino',
            self::CHURCH => 'Kirche',
            self::SPORTS_FACILITY => 'Sportstätte',
            self::PLAYGROUND => 'Spielplatz',
            self::CLIMBING_HALL => 'Kletterhalle',
            self::PARK => 'Park',
            self::OTHER_RECREATIONAL_FACILITY => 'Sonstige Freizeitstätte',
            self::SIGHT => 'Sehenswürdigkeit',
            self::TOWN_HALL => 'Rathaus',
            self::CITIZENS_BUREAU => 'Bürgerbüro',
            self::CIVIC_CENTER => 'Bürgerzentrum, Bürgerhaus',
            self::COURT => 'Gericht',
            self::OTHER_PUBLIC_FACILITY => 'Sonstige öffentliche Einrichtung'
        };
    }

    public function getShortName(): string
    {
        return match ($this) {
            self::KIOSK => 'KI',
            self::GAS_STATION => 'TS',
            self::PRICE_BREAKER => 'PB',
            self::RETAIL_WITHOUT_SHOWROOM => 'OV',
            self::SPECIALITY_STORE => 'FG',
            self::SPECIALITY_MARKET => 'FM',
            self::SUPERMARKET => 'SM',
            self::CONSUMER_MARKET => 'VM',
            self::SELF_SERVICE_DEPARTMENT_STORE => 'SB',
            self::DISCOUNTER => 'DIS',
            self::DEPARTMENT_STORE => 'KH',
            self::WAREHOUSE => 'WH',
            self::BOUTIQUE => 'BO',
            self::POPUP_STORE => 'PU',
            self::SHOWROOM => 'AF',
            self::FACTORY_OUTLET => 'FO',
            self::OFFICE => 'BUE',
            self::CO_WORKING_SPACE => 'COW',
            self::ATELIER => 'ATE',
            self::BANK => 'BAN',
            self::POST_OFFICE => 'POS',
            self::PRACTICE => 'PRA',
            self::WORKSHOP => 'WER',
            self::BEARING => 'LAG',
            self::ARCHIVE => 'ARC',
            self::LABORATORY => 'LAB',
            self::HOTEL => 'OT',
            self::INN => 'GAS',
            self::PENSION => 'PEN',
            self::YOUTH_HOSTEL => 'JUG',
            self::RESTAURANT => 'RES',
            self::RESTAURANT_WITH_SELF_SERVICE => 'RMS',
            self::COFFEE_SHOP => 'CAF',
            self::SNACK_BAR => 'IMB',
            self::PUB => 'BAR',
            self::ONE_ROOM_PUB => 'ERL',
            self::DISCOTHEQUE => 'TAN',
            self::CANTEEN => 'KANN',
            self::DELIVERY_SERVICE => 'CAT',
            self::BROTHEL => 'BOR',
            self::HIGH_BAY_WAREHOUSE => 'HRL',
            self::HALL => 'HAL',
            self::SHIPPING_COMPANY => 'SPE',
            self::PRODUCTION => 'PRO',
            self::COLD_STORAGE => 'KHA',
            self::DATA_CENTER => 'REZ',
            self::CAR_PARK => 'PAH',
            self::UNDERGROUND_CAR_PARK => 'TGA',
            self::PARKING_LOT => 'PAR',
            self::PARKING_SPACE => 'STL',
            self::GARAGE => 'GAR',
            self::LIBRARY => 'BIB',
            self::SCHOOL => 'SCH',
            self::UNIVERSITY => 'UNI',
            self::UNIVERSITY_OF_APPLIED_SCIENCE => 'HOS',
            self::RESEARCH_INSTITUTION => 'FOE',
            self::KINDERGARTEN => 'KIN',
            self::DAY_CARE_CENTER => 'KIT',
            self::ORPHANAGE => 'WAI',
            self::RETIREMENT_HOME => 'ALT',
            self::STUDENT_RESIDENCE => 'STW',
            self::WOMENS_SHELTER => 'FRH',
            self::NURSING_SERVICE => 'PFL',
            self::HOSPITAL => 'KRH',
            self::FIRE_STATION => 'FEW',
            self::POLICE_STATION => 'POW',
            self::RESCUE_STATION => 'REW',
            self::THEATER => 'THE',
            self::MUSEUM => 'MUS',
            self::CINEMA => 'KNO',
            self::CHURCH => 'KIR',
            self::SPORTS_FACILITY => 'SPS',
            self::PLAYGROUND => 'SPP',
            self::CLIMBING_HALL => 'KLH',
            self::PARK => 'PAK',
            self::OTHER_RECREATIONAL_FACILITY => 'SFS',
            self::SIGHT => 'SEH',
            self::TOWN_HALL => 'RAT',
            self::CITIZENS_BUREAU => 'BBO',
            self::CIVIC_CENTER => 'BGZ',
            self::COURT => 'GER',
            self::OTHER_PUBLIC_FACILITY => 'SOE'
        };
    }

    public function getDescription(): string
    {
        return match ($this) {
            self::KIOSK => 'Kleine Verkaufsstelle für Artikel des kurzfristigen Bedarfs in geringer Sortimentsbreite und -tiefe',
            self::PRICE_BREAKER => 'Hierzu gehören keine Discounter, sondern eher 1-Euro-Shops',
            self::RETAIL_WITHOUT_SHOWROOM => 'z. B. Versandhandel, Verkaufsstände am Straßenrand',
            self::SPECIALITY_STORE => 'Einzelhandelsbetrieb, der ein branchenspezifisches (z. B. Metzgerei, Spielwarengeschäft) oder bedarfsgruppenorientiertes (z. B. Babymarkt) Sortiment in großer Auswahl und in unterschiedlichen Qualitäten bei einer mittleren bis gehobenen Preisklasse mit ergänzenden Dienstleistungen (z. B. Kundendienst) anbietet; mittlere bis hohe Beratungsintensität, gute bis hohe Beratungskompetenz.',
            self::SPECIALITY_MARKET => 'Großflächiger Einzelhandelsbetrieb, der ein breites und oft auch tiefes Sortiment aus einem Warenbereich (z. B. Bekleidungs-, Schuhfachmarkt), einem Bedarfsbereich (z. B. Sport-, Baufachmarkt).',
            self::SUPERMARKET => 'Einzelhandelsbetrieb (Verkaufsfläche ab 400 qm bis unter 1.500 qm), der Nahrungs- und Genussmittel einschließlich Frischwaren (Obst, Gemüse, Fleisch, Fisch) und ergänzend Waren des täglichen Bedarfs anderer Branchen vorwiegend in Selbstbedienung anbietet.',
            self::CONSUMER_MARKET => 'Großflächiger Einzelhandelsbetrieb (Verkaufsfläche ab 1.500 qm bis unter 3.000 qm), der ein breites und tiefes Sortiment an Nahrungs- und Genussmitteln und an Ge- und Verbrauchsgütern des kurz- und mittelfristigen Bedarfs überwiegend in Selbstbedienung anbietet (häufig Dauerniedrigpreispolitik oder Sonderangebotspolitik). Standort in der Regel autokundenorientiert, in Alleinlage oder in Einzelhandelszentren.',
            self::SELF_SERVICE_DEPARTMENT_STORE => 'Großflächiger, meist ebenerdiger Einzelhandelsbetrieb (Verkaufsfläche ab 3.000 qm), der ein umfassendes Sortiment mit einem Schwerpunkt bei Lebensmitteln ganz oder überwiegend in Selbstbedienung anbietet (häufig Dauerniedrigpreispolitik oder Sonderangebotspolitik). Standort grundsätzlich autokundenorientiert, isoliert oder in gewachsenen oder geplanten Zentren.',
            self::DISCOUNTER => 'Schmales, auf raschen Umschlag ausgerichtetes Sortiment zu niedrigen Preisen, einfache Warenpräsentation und Ladenausstattung, so gut wie keine Beratung oder Kundendienstleistungen.',
            self::DEPARTMENT_STORE => 'Ein größerer Einzelhandelsbetrieb, der überwiegend im Wege der Bedienung, Waren aus zwei oder mehr Branchen, davon wenigstens aus einer Branche in tiefer Gliederung, anbietet (häufig Textilien, Bekleidung), keine Lebensmittel.',
            self::WAREHOUSE => 'Großflächiger Einzelhandelsbetrieb, der in der Regel auf mehreren Etagen breite und überwiegend tiefe Sortimente mehrer Branchen anbietet. Das Warensortiment umfasst überwiegend Güter der Bereiche Bekleidung, Heimtextilien, Sport, Hausrat, Einrichtung, Kosmetik, Drogeriewaren, Schmuck, Unterhaltung sowie auch Lebensmittel. Die Verkaufsmethode reicht von Bedienung bis zur Selbstbedienung. Eine Verkaufsfläche von in der Regel ab 3.000 qm ist erforderlich.',
            self::BOUTIQUE => 'Laden, der auf geringer Verkaufsfläche in innerstädtischen Haupt- oder Nebenlagen mittels meist aufwendig gestalteter Ladenatmosphäre ein begrenztes, auf die jeweilige Zielgruppe ausgerichtetes Sortiment (meist Kleidung, Schmuck) anbietet.',
            self::POPUP_STORE => 'Vorübergehende Zwischennutzung in Form eines Popup-Stores'
        };
    }
}
